#include "address.h"
#include "customer.h"
#include "order.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(Address)

namespace qx {
template <> void register_class(QxClass<Address> & t)
{
   t.id(& Address::m_id, "addressId");
   t.data(& Address::m_street, "street");
   t.data(& Address::m_number, "number");
   t.data(& Address::m_city, "city");
   t.data(& Address::m_zipcode, "zipcode");

   t.relationManyToOne(& Address::m_customer, "customerId");
   t.relationManyToOne(& Address::m_order, "orderId");
}}

Address::Address(QObject *parent) : QObject(parent)
{}

long Address::id()
{
    return m_id;
}

QString Address::street() const
{
    return m_street;
}

void Address::setStreet(const QString &street)
{
    m_street = street;
}

QString Address::number() const
{
    return m_number;
}

void Address::setNumber(const QString &number)
{
    m_number = number;
}

QString Address::city() const
{
    return m_city;
}

void Address::setCity(const QString &city)
{
    m_city = city;
}

quint32 Address::zipcode() const
{
    return m_zipcode;
}

void Address::setZipcode(quint32 zipcode)
{
    m_zipcode = zipcode;
}

CustomerPtr Address::customer() const
{
    return m_customer;
}

void Address::setCustomer(const CustomerPtr &customer)
{
    m_customer = customer;
}

OrderPtr Address::order() const
{
    return m_order;
}

void Address::setOrder(const OrderPtr &order)
{
    m_order = order;
}
