#include "address.h"
#include "customer.h"
#include "order.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(Customer)

namespace qx {
template <> void register_class(QxClass<Customer> & t)
{
   t.id(& Customer::m_id, "customerId");
   t.data(& Customer::m_firstName, "firstName");
   t.data(& Customer::m_lastName, "lastName");

   t.relationManyToOne(& Customer::m_invoiceAddress, "addressId");
   t.relationOneToMany(& Customer::m_orders, "orders", "customerId");
}}


Customer::Customer(QObject *parent) : QObject(parent),
    m_id(0)
{}

long Customer::id() const
{
    return m_id;
}

QString Customer::firstName() const
{
    return m_firstName;
}

void Customer::setFirstName(const QString &firstName)
{
    m_firstName = firstName;
}

QString Customer::lastName() const
{
    return m_lastName;
}

void Customer::setLastName(const QString &lastName)
{
    m_lastName = lastName;
}

AddressPtr Customer::invoiceAddress() const
{
    return m_invoiceAddress;
}

void Customer::setInvoiceAddress(const AddressPtr &invoiceAddress)
{
    m_invoiceAddress = invoiceAddress;
}

OrderVec Customer::orders() const
{
    return m_orders;
}

void Customer::setOrders(const OrderVec &orders)
{
    m_orders = orders;
}
