#ifndef CUSTOMER_H
#define CUSTOMER_H

#include <QObject>
#include <QSharedPointer>
#include <QVector>

#include <QxOrm.h>

#include "export.h"

class Address;
class Order;

class Customer : public QObject
{
    Q_OBJECT
    QX_REGISTER_FRIEND_CLASS(Customer)

    public:
        typedef QSharedPointer<Address> AddressPtr;
    typedef QVector<QSharedPointer<Order>> OrderVec;

    explicit Customer(QObject *parent = nullptr);

    long id() const;

    QString firstName() const;
    void setFirstName(const QString &firstName);

    QString lastName() const;
    void setLastName(const QString &lastName);

    AddressPtr invoiceAddress() const;
    void setInvoiceAddress(const AddressPtr &invoiceAddress);

    OrderVec orders() const;
    void setOrders(const OrderVec &orders);

private:
    long m_id = -1;
    QString m_firstName;
    QString m_lastName;

    AddressPtr m_invoiceAddress;
    OrderVec m_orders;

};

QX_REGISTER_HPP_QXORM_EXAMPLE(Customer, qx::trait::no_base_class_defined, 0)

typedef QSharedPointer<Customer> CustomerPtr;
typedef QVector<QSharedPointer<Customer>> CustomerVec;

#endif // CUSTOMER_H
