#include "machine.h"
#include "productiondata.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(Machine)

namespace qx {
template <> void register_class(QxClass<Machine> & t)
{
   t.id(& Machine::m_id, "machineId");
   t.data(& Machine::m_state, "state");
   t.relationOneToMany(& Machine::m_productionData, "productionsData", "machineId");
}}

Machine::Machine(QObject *parent) : QObject(parent)
{}

long Machine::id()
{
    return m_id;
}

Machine::States Machine::state()
{
    return m_state;
}

void Machine::setState(States state)
{
    m_state = state;
}

Machine::ProductionDataVec Machine::productionData() const
{
    return m_productionData;
}

void Machine::setProductionData(const ProductionDataVec &productionData)
{
    m_productionData = productionData;
}
