#include "address.h"
#include "customer.h"
#include "order.h"
#include "orderpiece.h"
#include "productiondata.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(Order)

namespace qx {
template <> void register_class(QxClass<Order> & t)
{
    t.setName("Orders");
    t.id(& Order::m_id, "orderId");
    t.data(& Order::m_date, "date");
    t.data(& Order::m_state, "state");

    t.relationManyToOne(& Order::m_customer, "customer");
    t.relationOneToMany(& Order::m_orderPieces, "orderPieces", "orderId");
    t.relationOneToMany(& Order::m_productionData, "productionData", "orderId");
    t.relationManyToOne(& Order::m_deliveryAddress, "deliveryAddress");
}}

Order::Order(QObject *parent) : QObject(parent)
{}

long Order::id() const
{
    return m_id;
}

QDateTime Order::date() const
{
    return m_date;
}

void Order::setDate(const QDateTime &date)
{
    m_date = date;
}

Order::States Order::state() const
{
    return m_state;
}

void Order::setState(const States &state)
{
    m_state = state;
}

CustomerPtr Order::customer() const
{
    return m_customer;
}

void Order::setCustomer(const CustomerPtr &customer)
{
    m_customer = customer;
}

ProductionDataVec Order::productionData() const
{
    return m_productionData;
}

void Order::setProductionData(const ProductionDataVec &productionData)
{
    m_productionData = productionData;
}

OrderPieceVec Order::orderPieces() const
{
    return m_orderPieces;
}

void Order::setOrderPieces(const OrderPieceVec &orderPieces)
{
    m_orderPieces = orderPieces;
}

AddressPtr Order::deliveryAddress() const
{
    return m_deliveryAddress;
}

void Order::setDeliveryAddress(const AddressPtr &deliveryAddress)
{
    m_deliveryAddress = deliveryAddress;
}
