#include "order.h"
#include "orderpiece.h"
#include "productiondata.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(OrderPiece)

namespace qx {
template <> void register_class(QxClass<OrderPiece> & t)
{
   t.id(& OrderPiece::m_id, "orderPieceId");

   t.data(& OrderPiece::m_width, "width");
   t.data(& OrderPiece::m_height, "height");
   t.data(& OrderPiece::m_length, "length");
   t.data(& OrderPiece::m_material, "material");
   t.relationManyToOne(& OrderPiece::m_order, "parentOrder");
   t.relationManyToOne(& OrderPiece::m_productionData, "productionData");
}}

OrderPiece::OrderPiece(QObject *parent) : QObject(parent)
{}

long OrderPiece::id() const
{
    return m_id;
}

double OrderPiece::getWidth() const
{
    return m_width;
}

void OrderPiece::setWidth(double value)
{
    m_width = value;
}

double OrderPiece::getHeight() const
{
    return m_height;
}

void OrderPiece::setHeight(double value)
{
    m_height = value;
}

double OrderPiece::getLength() const
{
    return m_length;
}

void OrderPiece::setLength(double value)
{
    m_length = value;
}

QString OrderPiece::getMaterial() const
{
    return m_material;
}

void OrderPiece::setMaterial(const QString &value)
{
    m_material = value;
}

OrderPtr OrderPiece::getOrder() const
{
    return m_order;
}

void OrderPiece::setOrder(const OrderPtr &order)
{
    m_order = order;
}

ProductionDataPtr OrderPiece::getProductionData() const
{
    return m_productionData;
}

void OrderPiece::setProductionData(const ProductionDataPtr &productionData)
{
    m_productionData = productionData;
}
