#include "machine.h"
#include "order.h"
#include "orderpiece.h"
#include "productiondata.h"

QX_REGISTER_CPP_QXORM_EXAMPLE(ProductionData)

namespace qx {
template <> void register_class(QxClass<ProductionData> & t)
{
   t.id(& ProductionData::m_id, "productionDataId");
   t.data(& ProductionData::m_toolId, "tool");
   t.data(& ProductionData::m_programId, "program");

   t.relationManyToOne(& ProductionData::m_machine, "machine");
   t.relationManyToOne(& ProductionData::m_orderPiece, "orderPiece");
   t.relationManyToOne(& ProductionData::m_order, "parentOrder");
}}

ProductionData::ProductionData(QObject *parent) : QObject(parent)
{}

long ProductionData::id() const
{
    return m_id;
}

quint32 ProductionData::toolId() const
{
    return m_toolId;
}

void ProductionData::setToolId(const quint32 &toolId)
{
    m_toolId = toolId;
}

quint32 ProductionData::programId() const
{
    return m_programId;
}

void ProductionData::setProgramId(const quint32 &programId)
{
    m_programId = programId;
}

MachinePtr ProductionData::machine() const
{
    return m_machine;
}

void ProductionData::setMachine(const MachinePtr &machine)
{
    m_machine = machine;
}

OrderPtr ProductionData::order() const
{
    return m_order;
}

void ProductionData::setOrder(const OrderPtr &order)
{
    m_order = order;
}

OrderPiecePtr ProductionData::orderPiece() const
{
    return m_orderPiece;
}

void ProductionData::setOrderPiece(const OrderPiecePtr &orderPiece)
{
    m_orderPiece = orderPiece;
}
